#-*-coding:utf-8-*-
"""
Outil d'installation d'application web
>>> w = WebAppsInstaller(myconffilename.json)
>>> myapp_to_install = w.get_application(appname)
>>> w.install(myapp_to_install)
>>> current_log_lines = myapp.tail()
"""
from twisted.python import log

from zephir.monitor.agents.web import Web

from ead2.backend.actions.tools import command_statusoutput as command
from ead2.backend.actions.lib.error import exception
from ead2.backend.actions.lib.envole.install.loader import WebAppsConf

class WebAppsInstaller(WebAppsConf):
    """
        Installeur d'objet
    """
    @staticmethod
    def test_web():
        """
            Teste la disponibilité du web
        """
        measure = Web("monagent_de_transit", "scribe").measure()
        for datas in measure:
            if datas['status'] != 'On':
                message = "Votre serveur rencontre un problème avec le " + \
                          "service suivant : \"%s\" " % (datas['service'],)
                exception(message)
        return True

    @staticmethod
    def query_auto():
        """
            lance un query-auto
        """
        log.msg("  + Lancement de la commande Query-Auto")
        ret_code, ret_value = command("/usr/bin/Query-Auto -W")
        if ret_code:
            log.err("  - Une erreur est survenue au lancement de la \
commande Query-Auto")
            log.err(ret_value)
            exception("Erreur à la mise à niveau du listing des " + \
                    "applications. Veuillez contacter votre administrateur")
        else:
            return True

    def install(self, app_package):
        """
            :app_package:Objet de type Package
        """
        if self.query_auto():
            app_package.install()
#
#    def update(self, app_package):
#        """
#            :app_package:Objet de type Package
#        """
#        if self.query_auto():
#            app_package.update()
