#-*-coding:utf-8-*-
"""
    Action d'installation des actions envole
"""
from twisted.python import log
from twisted.internet.defer import Deferred

from ead2.backend.lib.action import Dict
from ead2.backend.actions.lib.main import Main
from ead2.backend.actions.lib.error import _clean_errors, exception
from ead2.backend.actions.lib.widgets import ajax, main as M, form as F
from ead2.backend.actions.lib.envole.install.installer import WebAppsInstaller
from ead2.backend.actions.tools import format_form_result

ENVOLE_APPS_JSON = '/etc/sysconfig/envole/envole_apps.json'

class EnvoleInstall(Main):
    """
        Outil d'installation d'application web pour Envole
    """
    name = "envole_install"
    category = "Envole"
    libelle = "Installation d'applications"
    description = "Installation d'application web  Scribe"
    # templates utilisés
    widget_templates = ['main', 'form', 'formselect']
    template = 'envole_install'

    # entrées de requête
    request = Dict(default={},
            doc="arguments de la requete en cours cote frontend",
            keys=['server', 'action'])
    form_result = Dict(default={},
                       doc="",
                       keys=[''])

    def execute(self):
        """
            Répond aux appels du frontend
        """
        self.parse_request()
        if not self.memory.has_key('installer'):
            self.remember("installer", WebAppsInstaller(ENVOLE_APPS_JSON))

#        conf = WebAppsConf
        # 1- Test d'un éventuel lock
        # 2- Test de l'accès au web
        # 3- Récupération de la liste des applications disponibles et de leur état (dpkg, dico_creole)
        # 4- Génération du formulaire
